#include <Arduino.h>
// Secret sauce area!
// This fixes bad assumptions that the Arduino team made in various versions.
// C++ already defines these.
#ifdef true
#undef true
#endif
#ifdef false
#undef false
#endif
#include <cdcacm.h>
#include <SPI.h>

#define       DIAG_PORT Serial
#define    SERIAL_SPEED 115200

#define            MX1B 23
#define            MX1W 25
#define            MX2B 27
#define            MX2W 29
#define            MX3B 31
#define            MX3W 33
#define            MX4B 35
#define            MX4W 37
#define            MX5B 69
#define            MX5W 68
#define            MX6B 67
#define            MX6W 66
#define            MX7B 48
#define            MX7W 49

// 1
#define           MTR_G 47
// 5
#define           MTR_R 62

// 2
#define           MTR_K 45
// 6
#define           MTR_Y 44

// 3
#define           MTR_W 42
// 7
#define           MTR_N 43

// 4
#define           MTR_B 40
// 8
#define           MTR_O 41

// Optical
#define       MXO_ON(x) (digitalRead(x))
#define      MXO_OFF(x) (!digitalRead(x))

/**
 * ACM async control class extension
 *
 * @param pacm ACM class instance pointer
 * @return
 */
class ACMAsyncOper : public CDCAsyncOper {
public:
        uint8_t OnInit(ACM *pacm);
};

/**
 * Extra Initialization for ACM
 *
 * @param pacm ACM class instance pointer
 * @return Zero for success, or error code
 */
uint8_t ACMAsyncOper::OnInit(ACM *pacm) {
        uint8_t rcode;
        rcode = pacm->SetControlLineState(3);


        LINE_CODING lc;
        lc.dwDTERate = 9600;
        lc.bCharFormat = 0;
        lc.bParityType = 0;
        lc.bDataBits = 8;

        rcode = pacm->SetLineCoding(&lc);


        if(rcode) {
                ErrorMessage<uint8_t>(PSTR("SetLineCoding"), rcode);
                return rcode;
        }
        pacm->epInfo[pacm->epDataOutIndex].bmNakPower = USB_NAK_NOWAIT;
        delay(50);
        return rcode;
}

USB Usb;
ACMAsyncOper AsyncOper;
ACM Acm(&Usb, &AsyncOper);

boolean fail;
int what;
void setup() {
	fail = false;

        DIAG_PORT.begin(115200);
        Serial.println();
        Serial.println();
        Serial.println();
        DIAG_PORT.print("I/O test...");
        for(int i = 0; i < 256 && !fail; i++) {
                pinMode(MX1B, INPUT);
                pinMode(MX2B, INPUT);
                pinMode(MX3B, INPUT);
                pinMode(MX4B, INPUT);
                pinMode(MX5B, INPUT);
                pinMode(MX6B, INPUT);
                pinMode(MX7B, INPUT);
                pinMode(MTR_R, INPUT);
                pinMode(MTR_Y, INPUT);
                pinMode(MTR_N, INPUT);
                pinMode(MTR_O, INPUT);


                pinMode(MX1W, OUTPUT);
                pinMode(MX2W, OUTPUT);
                pinMode(MX3W, OUTPUT);
                pinMode(MX4W, OUTPUT);
                pinMode(MX5W, OUTPUT);
                pinMode(MX6W, OUTPUT);
                pinMode(MX7W, OUTPUT);
                pinMode(MTR_G, OUTPUT);
                pinMode(MTR_K, OUTPUT);
                pinMode(MTR_W, OUTPUT);
                pinMode(MTR_B, OUTPUT);

                digitalWrite(MX1W, LOW);
                digitalWrite(MX2W, LOW);
                digitalWrite(MX3W, LOW);
                digitalWrite(MX4W, LOW);
                digitalWrite(MX5W, LOW);
                digitalWrite(MX6W, LOW);
                digitalWrite(MX7W, LOW);
                digitalWrite(MTR_G, LOW);
                digitalWrite(MTR_K, LOW);
                digitalWrite(MTR_W, LOW);
                digitalWrite(MTR_B, LOW);

                delay(10);
                if(MXO_ON(MX1B)) {
                        DIAG_PORT.println("MX1B ON");
                        fail = true;
			what = MX1B;
                }
                if(MXO_ON(MX2B)) {
                        DIAG_PORT.println("MX2B ON");
                        fail = true;
			what = MX2B;
                }
                if(MXO_ON(MX3B)) {
                        DIAG_PORT.println("MX3B ON");
                        fail = true;
			what = MX3B;
                }
                if(MXO_ON(MX4B)) {
                        DIAG_PORT.println("MX4B ON");
                        fail = true;
			what = MX4B;
                }
                if(MXO_ON(MX5B)) {
                        DIAG_PORT.println("MX5B ON");
                        fail = true;
			what = MX5B;
                }
                if(MXO_ON(MX6B)) {
                        DIAG_PORT.println("MX6B ON");
                        fail = true;
			what = MX6B;
                }
                if(MXO_ON(MX7B)) {
                        DIAG_PORT.println("MX7B ON");
                        fail = true;
			what = MX7B;
                }
                if(MXO_ON(MTR_R)) {
                        DIAG_PORT.println("MTR_R ON");
                        fail = true;
			what = MTR_R;
                }
                if(MXO_ON(MTR_Y)) {
                        DIAG_PORT.println("MTR_Y ON");
                        fail = true;
			what = MTR_Y;
                }
                if(MXO_ON(MTR_N)) {
                        DIAG_PORT.println("MTR_N ON");
                        fail = true;
			what = MTR_N;
                }
                if(MXO_ON(MTR_O)) {
                        DIAG_PORT.println("MTR_O ON");
                        fail = true;
			what = MTR_O;
                }

                digitalWrite(MX1W, HIGH);
                digitalWrite(MX2W, HIGH);
                digitalWrite(MX3W, HIGH);
                digitalWrite(MX4W, HIGH);
                digitalWrite(MX5W, HIGH);
                digitalWrite(MX6W, HIGH);
                digitalWrite(MX7W, HIGH);
                digitalWrite(MTR_G, HIGH);
                digitalWrite(MTR_K, HIGH);
                digitalWrite(MTR_W, HIGH);
                digitalWrite(MTR_B, HIGH);

                delay(10);
                if(MXO_OFF(MX1B)) {
                        DIAG_PORT.println("MX1B OFF");
                        fail = true;
			what = MX1B;
                }
                if(MXO_OFF(MX2B)) {
                        DIAG_PORT.println("MX2B OFF");
                        fail = true;
			what = MX2B;
                }
                if(MXO_OFF(MX3B)) {
                        DIAG_PORT.println("MX3B OFF");
                        fail = true;
			what = MX3B;
                }
                if(MXO_OFF(MX4B)) {
                        DIAG_PORT.println("MX4B OFF");
                        fail = true;
			what = MX4B;
                }
                if(MXO_OFF(MX5B)) {
                        DIAG_PORT.println("MX5B OFF");
                        fail = true;
			what = MX5B;
                }
                if(MXO_OFF(MX6B)) {
                        DIAG_PORT.println("MX6B OFF");
                        fail = true;
			what = MX6B;
                }
                if(MXO_OFF(MX7B)) {
                        DIAG_PORT.println("MX7B OFF");
                        fail = true;
			what = MX7B;
                }
                if(MXO_OFF(MTR_R)) {
                        DIAG_PORT.println("MTR_R OFF");
                        fail = true;
			what = MTR_R;
                }
                if(MXO_OFF(MTR_Y)) {
                        DIAG_PORT.println("MTR_Y OFF");
                        fail = true;
			what = MTR_Y;
                }
                if(MXO_OFF(MTR_N)) {
                        DIAG_PORT.println("MTR_N OFF");
                        fail = true;
			what = MTR_N;
                }
                if(MXO_OFF(MTR_O)) {
                        DIAG_PORT.println("MTR_O OFF");
                        fail = true;
			what = MTR_O;
                }


                pinMode(MX1W, INPUT);
                pinMode(MX2W, INPUT);
                pinMode(MX3W, INPUT);
                pinMode(MX4W, INPUT);
                pinMode(MX5W, INPUT);
                pinMode(MX6W, INPUT);
                pinMode(MX7W, INPUT);
                pinMode(MTR_G, INPUT);
                pinMode(MTR_K, INPUT);
                pinMode(MTR_W, INPUT);
                pinMode(MTR_B, INPUT);

                pinMode(MTR_R, OUTPUT);
                pinMode(MTR_Y, OUTPUT);
                pinMode(MTR_N, OUTPUT);
                pinMode(MTR_O, OUTPUT);
                pinMode(MX1B, OUTPUT);
                pinMode(MX2B, OUTPUT);
                pinMode(MX3B, OUTPUT);
                pinMode(MX4B, OUTPUT);
                pinMode(MX5B, OUTPUT);
                pinMode(MX6B, OUTPUT);
                pinMode(MX7B, OUTPUT);

                digitalWrite(MX1B, LOW);
                digitalWrite(MX2B, LOW);
                digitalWrite(MX3B, LOW);
                digitalWrite(MX4B, LOW);
                digitalWrite(MX5B, LOW);
                digitalWrite(MX6B, LOW);
                digitalWrite(MX7B, LOW);
                digitalWrite(MTR_R, LOW);
                digitalWrite(MTR_Y, LOW);
                digitalWrite(MTR_N, LOW);
                digitalWrite(MTR_O, LOW);

                delay(10);
                if(MXO_ON(MX1W)) {
                        DIAG_PORT.println("MX1W ON");
                        fail = true;
			what = MX1W;
                }
                if(MXO_ON(MX2W)) {
                        DIAG_PORT.println("MX2W ON");
                        fail = true;
			what = MX2W;
                }
                if(MXO_ON(MX3W)) {
                        DIAG_PORT.println("MX3W ON");
                        fail = true;
			what = MX3W;
                }
                if(MXO_ON(MX4W)) {
                        DIAG_PORT.println("MX4W ON");
                        fail = true;
			what = MX4W;
                }
                if(MXO_ON(MX5W)) {
                        DIAG_PORT.println("MX5W ON");
                        fail = true;
			what = MX5W;
                }
                if(MXO_ON(MX6W)) {
                        DIAG_PORT.println("MX6W ON");
                        fail = true;
			what = MX6W;
                }
                if(MXO_ON(MX7W)) {
                        DIAG_PORT.println("MX7W ON");
                        fail = true;
			what = MX7W;
                }
                if(MXO_ON(MTR_G)) {
                        DIAG_PORT.println("MTR_G ON");
                        fail = true;
			what = MTR_G;
                }
                if(MXO_ON(MTR_K)) {
                        DIAG_PORT.println("MTR_K ON");
                        fail = true;
			what = MTR_K;
                }
                if(MXO_ON(MTR_W)) {
                        DIAG_PORT.println("MTR_W ON");
                        fail = true;
			what = MTR_W;
                }
                if(MXO_ON(MTR_B)) {
                        DIAG_PORT.println("MTR_B ON");
                        fail = true;
			what = MTR_B;
                }


                digitalWrite(MX1B, HIGH);
                digitalWrite(MX2B, HIGH);
                digitalWrite(MX3B, HIGH);
                digitalWrite(MX4B, HIGH);
                digitalWrite(MX5B, HIGH);
                digitalWrite(MX6B, HIGH);
                digitalWrite(MX7B, HIGH);
                digitalWrite(MTR_R, HIGH);
                digitalWrite(MTR_Y, HIGH);
                digitalWrite(MTR_N, HIGH);
                digitalWrite(MTR_O, HIGH);

                delay(10);
                if(MXO_OFF(MX1W)) {
                        DIAG_PORT.println("MX1W OFF");
                        fail = true;
			what = MX1W;
                }
                if(MXO_OFF(MX2W)) {
                        DIAG_PORT.println("MX1W OFF");
                        fail = true;
			what = MX2W;
                }
                if(MXO_OFF(MX3W)) {
                        DIAG_PORT.println("MX1W OFF");
                        fail = true;
			what = MX3W;
                }
                if(MXO_OFF(MX4W)) {
                        DIAG_PORT.println("MX1W OFF");
                        fail = true;
			what = MX4W;
                }
                if(MXO_OFF(MX5W)) {
                        DIAG_PORT.println("MX1W OFF");
                        fail = true;
			what = MX5W;
                }
                if(MXO_OFF(MX6W)) {
                        DIAG_PORT.println("MX1W OFF");
                        fail = true;
			what = MX6W;
                }
                if(MXO_OFF(MX7W)) {
                        DIAG_PORT.println("MX1W OFF");
                        fail = true;
			what = MX7W;
                }
                if(MXO_OFF(MTR_G)) {
                        DIAG_PORT.println("MTR_G OFF");
                        fail = true;
			what = MTR_G;
                }
                if(MXO_OFF(MTR_K)) {
                        DIAG_PORT.println("MTR_K OFF");
                        fail = true;
			what = MTR_K;
                }
                if(MXO_OFF(MTR_W)) {
                        DIAG_PORT.println("MTR_W OFF");
                        fail = true;
			what = MTR_W;
                }
                if(MXO_OFF(MTR_B)) {
                        DIAG_PORT.println("MTR_B OFF");
                        fail = true;
			what = MTR_B;
                }

        }
        pinMode(MX1B, INPUT);
        pinMode(MX2B, INPUT);
        pinMode(MX3B, INPUT);
        pinMode(MX4B, INPUT);
        pinMode(MX5B, INPUT);
        pinMode(MX6B, INPUT);
        pinMode(MX7B, INPUT);
        pinMode(MTR_R, INPUT);
        pinMode(MTR_Y, INPUT);
        pinMode(MTR_N, INPUT);
        pinMode(MTR_O, INPUT);
	if(fail) {
        	DIAG_PORT.println("FAILED");
		pinMode(what, OUTPUT);
		digitalWrite(what, HIGH);		
	} else {
        	DIAG_PORT.println("PASS");
	}

        DIAG_PORT.print("Starting USB interface...");
        while(Usb.Init() == -1) {
                DIAG_PORT.print("\r\nERROR! OSCOKIRQ failed to assert. Please check board.");
        }
        DIAG_PORT.println("PASS");
        DIAG_PORT.print("\rNO USB");
        DIAG_PORT.flush();
}
boolean good = false;
void loop() {
        Usb.Task();
        if(!Acm.isReady() || (Usb.getUsbTaskState() != USB_STATE_RUNNING)) {
		if(good) {
	                DIAG_PORT.print("\rNO USB");
        	        DIAG_PORT.flush();
			good = false;
		}
        } else {
		if(!good) {
	                DIAG_PORT.print("\rPASS  ");
       	         	DIAG_PORT.flush();
			good = true;
		}
        }
	if(fail) {
		digitalWrite(what, HIGH);
		delay(200);
		digitalWrite(what, LOW);
		delay(200);
	}
}
